package com.ulsanonline.triominoes;

/* 
 * 07/15/2012 - v3.2 - removed AlarmManager call on settings change
 * 12/02/2012 - v3.7 - showScorePopUps is checked 
 * 01/06/2013 - v4.0 - added AndroidPlayDifficult switch
 *                     added ShowAndroidTiles settings
 *                     removed ShowCenters settings
 */

import java.util.Calendar;

import android.app.Activity;
import android.app.AlarmManager;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.Spinner;
import android.widget.TextView;

import com.ulsanonline.triominoes.Settings;

public class ChangeSettings extends Activity {
	
	private Spinner spinner;
	private triDbAdapter mDbHelper;
	private final long FIVE_MIN = 5*60*1000;

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.settings);
		mDbHelper = new triDbAdapter(getApplicationContext());
		mDbHelper.open();
		spinner = (Spinner) findViewById(R.id.spinner1);
	    ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(
	            this, R.array.alarm_delay, android.R.layout.simple_spinner_item);
	    adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	    spinner.setAdapter(adapter);

	    if (Settings.AlarmInterval == FIVE_MIN) spinner.setSelection(0);
	    if (Settings.AlarmInterval == AlarmManager.INTERVAL_HALF_HOUR) spinner.setSelection(1);
	    if (Settings.AlarmInterval == AlarmManager.INTERVAL_HOUR) spinner.setSelection(2);
	    if (Settings.AlarmInterval == AlarmManager.INTERVAL_HOUR * 4) spinner.setSelection(3);
	    if (Settings.AlarmInterval == AlarmManager.INTERVAL_DAY) spinner.setSelection(4);
	    if (Settings.AlarmInterval == 0) spinner.setSelection(5);

        
	    spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
	        public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
	            //Object item = parent.getItemAtPosition(pos);
	            //Resources res = getResources();
	            //String[] delays = res.getStringArray(R.array.alarm_delay);
	            //if (item.equals(delays[0])) {
	            switch (pos) {
	            case 0 :
	            	Settings.AlarmInterval = FIVE_MIN;
	            	break;
	            case 1:
	            	Settings.AlarmInterval = AlarmManager.INTERVAL_HALF_HOUR;
	            	break;
	            case 2:
	            	Settings.AlarmInterval = AlarmManager.INTERVAL_HOUR;
	            	break;
	            case 3:
	            	Settings.AlarmInterval = AlarmManager.INTERVAL_HOUR * 4;
	            	break;
	            case 4:
	            	Settings.AlarmInterval = AlarmManager.INTERVAL_DAY;
	            	break;
	            case 5:
	            	Settings.AlarmInterval = 0;
	            	break;
	            }

	            mDbHelper.setAlarmInterval();
	            //if (item.equals(R.array.alarm_delay(0))
	        }
	        public void onNothingSelected(AdapterView<?> parent) {
	        }
	    });
	

	    
	    CheckBox alarmvibrate = (CheckBox) findViewById(R.id.alarm_vib);
	    if (Settings.AlarmVibrate) alarmvibrate.setChecked(true);
	    CheckBox alarmsound = (CheckBox) findViewById(R.id.alarm_sound);
	    if (Settings.AlarmSound) alarmsound.setChecked(true);
	    CheckBox board = (CheckBox) findViewById(R.id.showboard);
	    if (Settings.ShowBoard) board.setChecked(true);
	    CheckBox touch = (CheckBox) findViewById(R.id.showtouch);
	    if (Settings.ShowTouch) touch.setChecked(true);
	    CheckBox gamesound = (CheckBox) findViewById(R.id.enablesound);
	    if (Settings.EnableSound) gamesound.setChecked(true);
	    CheckBox scorepopups = (CheckBox) findViewById(R.id.showscorepopups);
	    if (Settings.ShowScorePopUps) scorepopups.setChecked(true);
	    // android play specifics
	    CheckBox centers = (CheckBox) findViewById(R.id.showandroidtiles);
	    if (Settings.ShowAndroidTiles) centers.setChecked(true);
	    
        CheckBox difficulty = (CheckBox) findViewById(R.id.androiddifficult);
        if (Settings.AndroidPlayDifficult) {
        	difficulty.setChecked(true);
        	difficulty.setText(getResources().getString(R.string.hard_play));
        }
        else {
        	difficulty.setChecked(false);
        	difficulty.setText(getResources().getString(R.string.easy_play));
        }
	}
	

	// Will be called via the onClick attribute
	// of the buttons in main.xml
	public void onClickSetFlag(View view) {
		//@SuppressWarnings("unchecked")
	
		switch (view.getId()) {
		case R.id.alarm_vib:
			Settings.AlarmVibrate = !Settings.AlarmVibrate;
			mDbHelper.setAlarmVibrate();
			break;
			
		case R.id.alarm_sound:
			Settings.AlarmSound = !Settings.AlarmSound;
			mDbHelper.setAlarmSound();
			break;
			
		case R.id.showboard:
			Settings.ShowBoard = !Settings.ShowBoard;
			mDbHelper.setShowBoard();
			break;
			
		case R.id.showandroidtiles:
			Settings.ShowAndroidTiles = !Settings.ShowAndroidTiles;
			mDbHelper.setShowCenters();
			break;
			
		case R.id.showtouch:
			Settings.ShowTouch = !Settings.ShowTouch;
			mDbHelper.setShowTouch();
			break;
			
		case R.id.showscorepopups:
			Settings.ShowScorePopUps = !Settings.ShowScorePopUps;
			mDbHelper.setShowScorePopUps();
			break;
			
		case R.id.enablesound:
			Settings.EnableSound = !Settings.EnableSound;
			mDbHelper.setSound();
			break;
		
		
		case R.id.androiddifficult:
			Settings.AndroidPlayDifficult = !Settings.AndroidPlayDifficult;
			mDbHelper.setDifficulty();
			if (Settings.AndroidPlayDifficult) {
	        	((CheckBox) view).setText(getResources().getString(R.string.hard_play));
	        }
	        else {
	        	((CheckBox) view).setText(getResources().getString(R.string.easy_play));
	        }
			break;
		}
		
	}
}