package com.ulsanonline.triominoes;

/*
 * 03/18/2012 - v3.0 new addition to allow in-Game chatting
 * 12/22/2012 - v3.9   - game_id: int -> long
 * 04/09/2013 - v4.2   - chats must NOT be done on UI thread
 * 09/29/2013 - v4.3   - cleanup chat adapter 
 */

import org.json.JSONException;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.database.Cursor;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Looper;
import android.os.Message;
import android.text.format.DateUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.ViewGroup.MarginLayoutParams;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;

public class InGameChat extends Activity {

    private triDbAdapter mDbHelper;
    private ServerCommunication sComm;
	private MyDataAdapter myChatAdp;
    private Drawable myBkg;
    private Drawable hisBkg;
    private EditText chatLine;
    private Button send;
    private Button check;
    private long game_id;
    private int user_id;
    private ListView myTurn;
    private ProgressDialog dialogUI; 

    	
    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		String[] from;
        int[] to;
	
		super.onCreate(savedInstanceState);
		mDbHelper = new triDbAdapter(this);
		mDbHelper.open();
		sComm = new ServerCommunication(this); 
		

		dialogUI = new ProgressDialog(this);
		dialogUI.setMessage("Communicating...");  // I'll use this several times in the game
		
		
		// read my bundle
		Bundle extras = getIntent().getExtras();
        game_id = extras.getLong(mDbHelper.KEY_ID);
        user_id = extras.getInt(mDbHelper.KEY_USERID);
		
        dialogUI.show();
		    Thread checkChat = new Thread() {  
		        public void run() {
	   		    	//
	   		    	// YOUR LONG CALCULATION (OR OTHER) GOES HERE
	   		    	//
	   		    	Looper.prepare();
			        // get the most recent chats
			        try {
						sComm.recvChat(game_id, user_id);
					} catch (JSONException e) {
						e.printStackTrace();
					}
			      //Looper.loop();
			    	handler.sendEmptyMessage(0);
			    }
			};
		checkChat.start();
        
		setContentView(R.layout.ingame_chat);
		setTitle("chat! ");
		
		send =  (Button)  findViewById(R.id.send);
		send.setOnClickListener(onSendMsg);
		
		check = (Button)  findViewById(R.id.check);
		check.setOnClickListener(onCheckForMsg);
		chatLine = (EditText) findViewById(R.id.msg);

		
		Cursor c = mDbHelper.fetchAllChats(game_id);
        startManagingCursor(c);

		from = new String[] {
                triDbAdapter.KEY_WHO, 
                triDbAdapter.KEY_CHAT, 
                triDbAdapter.KEY_WHEN};
                
        to = new int []  {R.id.who1,
	          R.id.said1}; 
        
        myTurn = (ListView)findViewById(R.id.ListView1);
        myChatAdp = new MyDataAdapter (this, R.layout.chat_msg, c, from, to);
        myTurn.setAdapter (myChatAdp);
		
		
		
	}
    
    private OnClickListener onSendMsg = new OnClickListener() {
        public void onClick(View v) { 

	    	final String newmsg;
	    	
	    	newmsg = chatLine.getText().toString();
	    	if (newmsg.length() > 0) {
	    		// stuff it into the Db should we need it again
	    		mDbHelper.insertChat(game_id, user_id, newmsg);
	    		
	    		// now paste it on the end of our llview of messages
	    		Cursor c = myChatAdp.getCursor();
	      		c.requery();
	    		// and then send it off to the server
	      		dialogUI.show();
 	   		    Thread sendChat = new Thread() {  
 	   		        public void run() {
	 	   		    	//
	 	   		    	// YOUR LONG CALCULATION (OR OTHER) GOES HERE
	 	   		    	//
	 	   		    	Looper.prepare();
			    		try {
							sComm.sendChat(game_id, user_id, newmsg);
						} catch (JSONException e) {
							e.printStackTrace();
						}
			    		//Looper.loop();
				    	handler.sendEmptyMessage(0);
				    }
				};
				sendChat.start();
				chatLine.setText("");
				//hide keyboard :
                InputMethodManager manager = (InputMethodManager)
                getSystemService(Context.INPUT_METHOD_SERVICE);
                IBinder binder = v.getApplicationWindowToken();
                if (binder != null) {
                    manager.hideSoftInputFromWindow(binder, 0);
                } 
                
	    	}
	    	
        }

	};
	
	private OnClickListener onCheckForMsg = new OnClickListener() {
        public void onClick(View v) { 

        	dialogUI.show();
		    Thread recvChat = new Thread() {  
		        public void run() {
	   		    	//
	   		    	// YOUR LONG CALCULATION (OR OTHER) GOES HERE
	   		    	//
	   		    	Looper.prepare();
			        // get the most recent chats
		    		// check the server for new msg
		    		try {
						sComm.recvChat(game_id, user_id);
					} catch (JSONException e) {
						e.printStackTrace();
					}
		    		//Looper.loop();
			    	handler.sendEmptyMessage(0);
			    }
			};
		    recvChat.start();
		    
		    
			// query the db and add new messages
    		Cursor c = myChatAdp.getCursor();
      		myChatAdp.notifyDataSetChanged();

        }

	};
	
	// when thread has finished, just kill the dialog
	final Handler handler = new Handler() {
	    public void handleMessage(Message msg) {
			dialogUI.dismiss();
		}
	};

	@Override
	protected void onPause() {
		super.onPause();
		mDbHelper.close();
		sComm.close();
	}
	
	public class MyDataAdapter extends SimpleCursorAdapter {
		private Cursor c;
		private Context context;
		
	    public MyDataAdapter(Context context, int layout, Cursor c, String[] from, int[] to) {
	    	super(context, layout, c, from, to);
	    	this.c = c;
		    this.context = context;
	    
	    }
    	
	    	
    	public View getView(final int pos, View inView, ViewGroup parent) {
			View vi=inView;
			 TextView who1;
			 TextView said1;
			 String player = "";
			 int bkgcolorTHEM = 0xFF778F6E;
			 int bkgcolorME = 0xFF7C5B77;
			 
	        
	        if (inView == null) {
	     	    LayoutInflater inflater = (LayoutInflater) context
		                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		        vi = inflater.inflate(R.layout.chat_msg, null);
		        
                

		    }
	        who1=(TextView)vi.findViewById(R.id.who1);
            said1=(TextView)vi.findViewById(R.id.said1);
     
            final ViewGroup.MarginLayoutParams lptW =(MarginLayoutParams) who1.getLayoutParams();
            final ViewGroup.MarginLayoutParams lptS =(MarginLayoutParams) said1.getLayoutParams();
			

            c.moveToPosition(pos);
            final int who = c.getInt(c.getColumnIndexOrThrow(mDbHelper.KEY_WHO));
            final String said = c.getString(c.getColumnIndexOrThrow(mDbHelper.KEY_CHAT));
            final String when = (String) DateUtils.getRelativeTimeSpanString (c.getLong(
		               c.getColumnIndex(triDbAdapter.KEY_WHEN)));
            if (who == user_id) {
				player = "you"; 
                said1.setBackgroundColor(bkgcolorME);
                lptW.setMargins(5,lptW.topMargin,lptW.rightMargin,lptW.bottomMargin); 
                lptS.setMargins(5,lptS.topMargin,lptS.rightMargin,lptS.bottomMargin); 
			}
			else {
				player = mDbHelper.getOpponentName(game_id); 
                said1.setBackgroundColor(bkgcolorTHEM);
                lptW.setMargins(100,lptW.topMargin,lptW.rightMargin,lptW.bottomMargin); 
                lptS.setMargins(100,lptS.topMargin,lptS.rightMargin,lptS.bottomMargin); 
			}

            String header = when + " " + player + " said:";
            who1.setText(header);
            said1.setText(said);

           
	        return vi;
    	}
    	
    	
	}

}
