package com.ulsanonline.triominoes;
/*
 * 02/25/2012 - Initial release
 * 07/15/2012 - v3.2 Store game play status in sharedPreferences for WakeCheck to read
 * 11/21/2012 - v3.5 check for bundle extras being null before extraction. close db on pause
 * 12/22/2012 - v3.9 game_id: int -> long
 *
 */

import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Toast;

import com.ulsanonline.triominoes.DrawBoardView;

public class TriOminoesStartActivity extends Activity {
	
	private View myView;
    private triDbAdapter mDbHelper;
    private Context mCtx;
	private PendingIntent pendingIntent;
    final static private String ACCOUNT_PREFS_NAME = "prefs";
    final static private String ACCESS_REMOTE = "ACCESS_REMOTE_KEY";
    private String TAG="TriominoesStart";

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mCtx = this;
		mDbHelper = new triDbAdapter(this.getApplicationContext());
		//mDbHelper.open();
		
        //Create, Initialise and then load the Sound manager
        SoundManager.getInstance();
        SoundManager.initSounds(this);
        SoundManager.loadSounds();
        
        Bundle extras = getIntent().getExtras();
        if (extras == null) { // check for null and terminate
    		Toast.makeText(this, "Activity Unable to start : Game ID = null", Toast.LENGTH_SHORT).show();
            finish();
        }
        else {
            long game_id = extras.getLong(mDbHelper.KEY_ID);  
 
	        // draw the view -  the game
	        setContentView(new DrawBoardView(this, game_id));
        }        


    }
    private OnClickListener doIt = new OnClickListener() {
        public void onClick(View v) {

        	BoardClass hc = new BoardClass();
        	if (hc.setScale == 1) hc.setScale= 2; else hc.setScale=1;  
        }

	};
	@Override
	protected void onStart() {
	    super.onStart();  // Always call the superclass method first
	    
	    // The activity is either being restarted or started for the first time
	    // so this is where we should make sure that any alarms on player moves won't go off
		// by setting sharedPreferences flag

        SharedPreferences prefs = getSharedPreferences(ACCOUNT_PREFS_NAME, 0);
        Editor edit = prefs.edit();
        edit.putBoolean(ACCESS_REMOTE, false);
        edit.commit();


	}


	
	@Override
	protected void onStop() {
	    super.onStop();  // Always call the superclass method first

	    // we're stopping. Start the alarm service to wake up and
	    // check for moves by other players.
		// by setting sharedPreferences flag
	    SharedPreferences prefs = getSharedPreferences(ACCOUNT_PREFS_NAME, 0);
        Editor edit = prefs.edit();
        edit.putBoolean(ACCESS_REMOTE, true);
        edit.commit();


	}
	
	
	@Override
	protected void onResume() {
		
		super.onResume();
		//mDbHelper.open();
		//Log.d(TAG, "open on resume");
		
	}

	@Override
	protected void onPause() {
		
		super.onPause();
		Log.d(TAG, "close onPause");
		mDbHelper.close();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		SoundManager.cleanup();
		Log.d(TAG, "close onDestroy");
		mDbHelper.close();
	}
}