package com.ulsanonline.triominoes;

/*
 * 01/06/2013 - v4.0 - rotating tile now takes a boolean to set bitmap or just set scores
 * 
 */


import java.util.ArrayList;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Point;
import android.util.Log;

public class tileClass {
	
	public int rotate;        // 6 possible values of a triangle orientation
    public Boolean inPlay;    // tile is one of the player's hands and hasn't been played and is not in the bone pile
    public Boolean played;    // tile has been played, but is no longer in a player's hand
    private Boolean facedown;  // either downward pointing triangle or upward pointing. Initially all upward until user
                              // rotates the tile
    public int board_index;   // index into board grid on which this tile sits.
    public String fname;
    public int tileIndex;     // 
	private static final String TAG = "tileClass";
	private static Bitmap faces[]; // the images of the tile, one pointed up, one down
	private static Bitmap scoresBm[];// the images of the scores on each vertex
	private Bitmap tile; 
	private int scores[]; // the actual point values of the vertices
    private ArrayList<Point> vertex =  new ArrayList<Point>(); 
    private int initScores[];
	private int coordX = 0; // the x coordinate at the canvas
	private int coordY = 0; // the y coordinate at the canvas
	private int sizeX = 0;  // size of the tile
	private int sizeY = 0;
	private static int count = 1;
	/*
	 * constructor
	 */
	
public tileClass(Context context, int fsize, int ssize) {
	    faces = new Bitmap[2];   // shape is a triangle, 1 up, 2 down and 3 scores
	    // now get the faces
	 	faces[0] =  (Bitmap) BitmapFactory.decodeResource(context.getResources(), R.drawable.face_up);
	 	faces[1] =  (Bitmap) BitmapFactory.decodeResource(context.getResources(), R.drawable.face_dn);
	 	for (int i = 0; i < 2; i++ ){
	 			
	 		    
 		    int oldWidth = faces[i].getWidth();
 			int oldHeight = faces[i].getHeight();
 			
 	
 			// calculate the scale
 			float newWidth = fsize;
			float scaleWidth = ((float) newWidth) / oldWidth;
 			float newHeight = fsize;
			float scaleHeight = ((float)newHeight) / oldHeight;
 	
 			// create a matrix for the manipulation
 			Matrix matrix = new Matrix();
 			// resize the bit map
 			matrix.postScale(scaleWidth, scaleHeight);
 	
 			// recreate the new Bitmap
 			Bitmap newbkg = Bitmap.createBitmap(faces[i], 0, 0,  oldWidth, oldHeight, matrix, true);	
 			faces[i] = newbkg.copy(Bitmap.Config.ARGB_8888, true);
 		    
 		    float density = faces[i].getDensity() / 160;  // get dpi
 		   
 		    
 		    sizeX = (int)(faces[i].getWidth());// * density);
 	        sizeY = (int)(faces[i].getHeight());// * density);
 	        
 		    newbkg.recycle();
 	      

 		}
	 		
	 	// now do the same with the point bitmaps

		int newWidth =  ssize;
		int newHeight = ssize;  
		scoresBm = new Bitmap[6];
		for (int i = 0; i < 6; i++ ){
			  String fname = "p" + i;
			  int id = context.getResources().getIdentifier(fname, "drawable", "com.ulsanonline.triominoes");
		      if (id == 0) {
		          Log.e(TAG, "Lookup id for resource '"+fname+"' failed");
		          // graceful error handling code here
		      }
		      scoresBm[i] =  (Bitmap) BitmapFactory.decodeResource(context.getResources(), id);
		      int oldWidth = scoresBm[i].getWidth();
		      int oldHeight = scoresBm[i].getHeight();
	 		  float scaleWidth = ((float) newWidth) / oldWidth;
			  float scaleHeight = ((float)newHeight) / oldHeight;
		      Matrix matrix = new Matrix();
	   		  matrix.postScale(scaleWidth, scaleHeight);
	 		  Bitmap newbkg = Bitmap.createBitmap(scoresBm[i], 0, 0,  oldWidth, oldHeight, matrix, true);	
			  scoresBm[i] = newbkg.copy(Bitmap.Config.ARGB_8888, true);   
		}

		
	}
	
	public tileClass(Context context, int ID, String nameID, Point point, int fsize, int ssize ) {
        // input a t3-digit string/number and produce one of the tiles in bitmap form
	   
	    tileIndex = ID;
	    fname = nameID;
	    inPlay = false;
	    played = false;
	    scores = new int[3];
	    initScores = new int[3];
	    board_index=-1;
	    //convert string into array using toCharArray() method of string class
		char[] stringArray;
		if (nameID.equals("")) nameID = "t000";
  	    stringArray = nameID.toCharArray();
	   
	    //set the score using the 3-digits in the name
	    initScores[0] = Integer.parseInt( String.valueOf(stringArray[1]) );
	    initScores[1] = Integer.parseInt( String.valueOf(stringArray[2]) );
	    initScores[2] = Integer.parseInt( String.valueOf(stringArray[3]) );
	    int midPt = fsize /2;
	    int halfBase = midPt / 2;
	    int alt = (fsize * 2)/3;
	    int topLeft = ssize / 2;
	    int margin = (int) (fsize * 0.1f);
	    
	    Point vpoint0 = new Point();	    
	    vpoint0.x = midPt - halfBase - topLeft;   // Base is down, lower left vertex
	    vpoint0.y = fsize - ssize - margin;
	    vertex.add(0,vpoint0);
	    Point vpoint1 = new Point();
	    vpoint1.x = midPt - topLeft;              // top center
	    vpoint1.y = fsize - alt - topLeft;
	    vertex.add(1,vpoint1);
	    Point vpoint2 = new Point();
	    vpoint2.x = midPt + halfBase - topLeft;   // lower right vertex
	    vpoint2.y = fsize - ssize - margin;
	    vertex.add(2,vpoint2);
	    
	    
	    
	    Point vpoint3 = new Point();
	    vpoint3.x = midPt - halfBase - topLeft;   // base is up, upper left vertex;
	    vpoint3.y =  ssize;
	    vertex.add(3,vpoint3);
	    Point vpoint4 = new Point();
	    vpoint4.x = midPt + halfBase - topLeft;   // upper right vertex
	    vpoint4.y =  ssize;
	    vertex.add(4,vpoint4);
	    Point vpoint5 = new Point();
	    vpoint5.x = midPt - topLeft;              // bottom center
	    vpoint5.y = alt - topLeft;
	    vertex.add(5,vpoint5);
	   
	    coordX= point.x;
		coordY = point.y;

		
		
		// get the score bitmaps associated with this face
		for (int i = 0; i < 3; i++) {
 		  scores[i] = initScores[i];        
		}
		
		 
		rotate = 0;
		inPlay = false;
		facedown = false;
		
		sizeX = (int)(faces[0].getWidth());// * density);
	    sizeY = (int)(faces[0].getHeight());// * density);
	    		
		// center the coords to the tile
        coordX = point.x + (int)((float)sizeX/2);
		coordY = point.y + (int)((float)sizeY/2);
		
		// set  up tile in it's initial state
		
        tile = Bitmap.createBitmap(faces[0]);
		Canvas c = new Canvas(tile);

        c.drawBitmap(tile, 0, 0, null);
    	c.drawBitmap(scoresBm[initScores[0]], vertex.get(0).x, vertex.get(0).y, null);
    	c.drawBitmap(scoresBm[initScores[1]], vertex.get(1).x, vertex.get(1).y, null);
    	c.drawBitmap(scoresBm[initScores[2]], vertex.get(2).x, vertex.get(2).y, null);

	}


	public static int getCount() {
		return count;
	}
	
	void setX(int newValue) {
        coordX = newValue;
    }
	
	public int getX() {
		return coordX;
	}
	
	public int getSizeX() {
		return sizeX;
	}
	
	public int getSizeY() {
		return sizeY;
	}

	void setY(int newValue) {
        coordY = newValue;
   }
	
	public int getY() {
		return coordY;
	}
	
	public int getID() {
		return tileIndex;
	}
	
	public Bitmap getBitmap() {
		return tile;
		
	}

	void setRotate(int newRotate, Boolean newBitMap){
	    
	    
		if (newRotate < 3) { // use face[0] which points up
		   
		   // draw the scores in the new places
		   switch (newRotate) {
		      case 0: 
		    	  scores[0] = initScores[0];
		    	  scores[1] = initScores[1];
		    	  scores[2] = initScores[2];
		    	  if (newBitMap) {
					  tile = Bitmap.createBitmap(faces[0]);
					  Canvas c = new Canvas(tile);
					  c.drawBitmap(tile, 0, 0, null);
				   
				      c.drawBitmap(scoresBm[initScores[0]], vertex.get(0).x, vertex.get(0).y, null);
		    	      c.drawBitmap(scoresBm[initScores[1]], vertex.get(1).x, vertex.get(1).y, null);
		    	      c.drawBitmap(scoresBm[initScores[2]], vertex.get(2).x, vertex.get(2).y, null);
		    	  }
	    	      break;
		      case 1:
		    	  scores[0] = initScores[2];
		    	  scores[1] = initScores[0];
		    	  scores[2] = initScores[1];
		    	  if (newBitMap) {
					  tile = Bitmap.createBitmap(faces[0]);
					  Canvas c = new Canvas(tile);
					  c.drawBitmap(tile, 0, 0, null);
			    	  c.drawBitmap(scoresBm[initScores[2]], vertex.get(0).x, vertex.get(0).y, null);
		    	      c.drawBitmap(scoresBm[initScores[0]], vertex.get(1).x, vertex.get(1).y, null);
		    	      c.drawBitmap(scoresBm[initScores[1]], vertex.get(2).x, vertex.get(2).y, null);
		    	  }
		    	  break;
		      case 2:
		    	  scores[0] = initScores[1];
		    	  scores[1] = initScores[2];
		    	  scores[2] = initScores[0];
		    	  if (newBitMap) {
					  tile = Bitmap.createBitmap(faces[0]);
					  Canvas c = new Canvas(tile);
					  c.drawBitmap(tile, 0, 0, null);
			          c.drawBitmap(scoresBm[initScores[1]], vertex.get(0).x, vertex.get(0).y, null);
	    	          c.drawBitmap(scoresBm[initScores[2]], vertex.get(1).x, vertex.get(1).y, null);
	    	          c.drawBitmap(scoresBm[initScores[0]], vertex.get(2).x, vertex.get(2).y, null);
		    	  }
		          break;
		   }
		}
		else {            // use downward pointing face
			
			// draw the scores in the new places
			switch (newRotate) {
		      case 3: 
		    	  
		    	  scores[0] = initScores[2];
		    	  scores[1] = initScores[0];
		    	  scores[2] = initScores[1];
		    	  if (newBitMap) {
		    		  tile = Bitmap.createBitmap(faces[1]);
		  			  Canvas c = new Canvas(tile);
		  			  c.drawBitmap(tile, 0, 0, null);
		    	  
				      c.drawBitmap(scoresBm[initScores[2]], vertex.get(3).x, vertex.get(3).y, null);
		    	      c.drawBitmap(scoresBm[initScores[0]], vertex.get(4).x, vertex.get(4).y, null);
		    	      c.drawBitmap(scoresBm[initScores[1]], vertex.get(5).x, vertex.get(5).y, null);
		    	  }
	    	      break;
		      case 4:
		    	  scores[0] = initScores[1];
		    	  scores[1] = initScores[2];
		    	  scores[2] = initScores[0];
		    	  if (newBitMap) {
		    		  tile = Bitmap.createBitmap(faces[1]);
		  			  Canvas c = new Canvas(tile);
		  			  c.drawBitmap(tile, 0, 0, null);
			    	  c.drawBitmap(scoresBm[initScores[1]], vertex.get(3).x, vertex.get(3).y, null);
		    	      c.drawBitmap(scoresBm[initScores[2]], vertex.get(4).x, vertex.get(4).y, null);
		    	      c.drawBitmap(scoresBm[initScores[0]], vertex.get(5).x, vertex.get(5).y, null);
		    	  }
		    	  break;
		      case 5:
		    	  scores[0] = initScores[0];
		    	  scores[1] = initScores[1];
		    	  scores[2] = initScores[2];
		    	  if (newBitMap) {
		    		  tile = Bitmap.createBitmap(faces[1]);
		  			  Canvas c = new Canvas(tile);
		  			  c.drawBitmap(tile, 0, 0, null);
			          c.drawBitmap(scoresBm[initScores[0]], vertex.get(3).x, vertex.get(3).y, null);
	  	              c.drawBitmap(scoresBm[initScores[1]], vertex.get(4).x, vertex.get(4).y, null);
	  	              c.drawBitmap(scoresBm[initScores[2]], vertex.get(5).x, vertex.get(5).y, null);
		    	  }
		      break;
		   }
		}
		
		rotate = newRotate;
	}
	
	public int getRotate() {
		return rotate;
	}
	
	public int getScore(int vert) {
		// return score at vertex vert;
		return scores[vert];
	}
	
	public Boolean isInPlay() {
		// if true, this tile is in someone's hand and not in the bone pile and not already on the board
		return inPlay;
	}
	
	public Boolean isFaceDown() {
		return (rotate > 2);  // rotations 3,4,5 are all upward pointing
	}

}
